


<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    
    
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for /private/tmp/im/impacket/impacket/dcerpc/v5/dcom/vds.py: 57%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">

<div id="header">
    <div class="content">
        <h1>Coverage for <b>/private/tmp/im/impacket/impacket/dcerpc/v5/dcom/vds.py</b> :
            <span class="pc_cov">57%</span>
        </h1>

        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />

        <h2 class="stats">
            141 statements &nbsp;
            <span class="run hide_run shortkey_r button_toggle_run">84 run</span>
            <span class="mis shortkey_m button_toggle_mis">57 missing</span>
            <span class="exc shortkey_x button_toggle_exc">0 excluded</span>

            
                <span class="par run hide_run shortkey_p button_toggle_par">0 partial</span>
            
        </h2>
    </div>
</div>

<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>

<div id="source">
    <table>
        <tr>
            <td class="linenos">
<p id="n1" class="pln"><a href="#n1">1</a></p>
<p id="n2" class="pln"><a href="#n2">2</a></p>
<p id="n3" class="pln"><a href="#n3">3</a></p>
<p id="n4" class="pln"><a href="#n4">4</a></p>
<p id="n5" class="pln"><a href="#n5">5</a></p>
<p id="n6" class="pln"><a href="#n6">6</a></p>
<p id="n7" class="pln"><a href="#n7">7</a></p>
<p id="n8" class="pln"><a href="#n8">8</a></p>
<p id="n9" class="pln"><a href="#n9">9</a></p>
<p id="n10" class="pln"><a href="#n10">10</a></p>
<p id="n11" class="pln"><a href="#n11">11</a></p>
<p id="n12" class="pln"><a href="#n12">12</a></p>
<p id="n13" class="pln"><a href="#n13">13</a></p>
<p id="n14" class="pln"><a href="#n14">14</a></p>
<p id="n15" class="pln"><a href="#n15">15</a></p>
<p id="n16" class="pln"><a href="#n16">16</a></p>
<p id="n17" class="pln"><a href="#n17">17</a></p>
<p id="n18" class="pln"><a href="#n18">18</a></p>
<p id="n19" class="pln"><a href="#n19">19</a></p>
<p id="n20" class="pln"><a href="#n20">20</a></p>
<p id="n21" class="pln"><a href="#n21">21</a></p>
<p id="n22" class="stm run hide_run"><a href="#n22">22</a></p>
<p id="n23" class="stm run hide_run"><a href="#n23">23</a></p>
<p id="n24" class="stm run hide_run"><a href="#n24">24</a></p>
<p id="n25" class="stm run hide_run"><a href="#n25">25</a></p>
<p id="n26" class="stm run hide_run"><a href="#n26">26</a></p>
<p id="n27" class="stm run hide_run"><a href="#n27">27</a></p>
<p id="n28" class="stm run hide_run"><a href="#n28">28</a></p>
<p id="n29" class="stm run hide_run"><a href="#n29">29</a></p>
<p id="n30" class="stm run hide_run"><a href="#n30">30</a></p>
<p id="n31" class="pln"><a href="#n31">31</a></p>
<p id="n32" class="stm run hide_run"><a href="#n32">32</a></p>
<p id="n33" class="stm run hide_run"><a href="#n33">33</a></p>
<p id="n34" class="stm mis"><a href="#n34">34</a></p>
<p id="n35" class="pln"><a href="#n35">35</a></p>
<p id="n36" class="stm run hide_run"><a href="#n36">36</a></p>
<p id="n37" class="stm mis"><a href="#n37">37</a></p>
<p id="n38" class="stm mis"><a href="#n38">38</a></p>
<p id="n39" class="stm mis"><a href="#n39">39</a></p>
<p id="n40" class="stm mis"><a href="#n40">40</a></p>
<p id="n41" class="pln"><a href="#n41">41</a></p>
<p id="n42" class="stm mis"><a href="#n42">42</a></p>
<p id="n43" class="pln"><a href="#n43">43</a></p>
<p id="n44" class="pln"><a href="#n44">44</a></p>
<p id="n45" class="pln"><a href="#n45">45</a></p>
<p id="n46" class="pln"><a href="#n46">46</a></p>
<p id="n47" class="pln"><a href="#n47">47</a></p>
<p id="n48" class="stm run hide_run"><a href="#n48">48</a></p>
<p id="n49" class="stm run hide_run"><a href="#n49">49</a></p>
<p id="n50" class="stm run hide_run"><a href="#n50">50</a></p>
<p id="n51" class="stm run hide_run"><a href="#n51">51</a></p>
<p id="n52" class="stm run hide_run"><a href="#n52">52</a></p>
<p id="n53" class="stm run hide_run"><a href="#n53">53</a></p>
<p id="n54" class="stm run hide_run"><a href="#n54">54</a></p>
<p id="n55" class="stm run hide_run"><a href="#n55">55</a></p>
<p id="n56" class="pln"><a href="#n56">56</a></p>
<p id="n57" class="stm run hide_run"><a href="#n57">57</a></p>
<p id="n58" class="pln"><a href="#n58">58</a></p>
<p id="n59" class="pln"><a href="#n59">59</a></p>
<p id="n60" class="stm run hide_run"><a href="#n60">60</a></p>
<p id="n61" class="pln"><a href="#n61">61</a></p>
<p id="n62" class="pln"><a href="#n62">62</a></p>
<p id="n63" class="pln"><a href="#n63">63</a></p>
<p id="n64" class="pln"><a href="#n64">64</a></p>
<p id="n65" class="pln"><a href="#n65">65</a></p>
<p id="n66" class="stm run hide_run"><a href="#n66">66</a></p>
<p id="n67" class="stm run hide_run"><a href="#n67">67</a></p>
<p id="n68" class="pln"><a href="#n68">68</a></p>
<p id="n69" class="pln"><a href="#n69">69</a></p>
<p id="n70" class="pln"><a href="#n70">70</a></p>
<p id="n71" class="pln"><a href="#n71">71</a></p>
<p id="n72" class="stm run hide_run"><a href="#n72">72</a></p>
<p id="n73" class="stm run hide_run"><a href="#n73">73</a></p>
<p id="n74" class="pln"><a href="#n74">74</a></p>
<p id="n75" class="pln"><a href="#n75">75</a></p>
<p id="n76" class="stm run hide_run"><a href="#n76">76</a></p>
<p id="n77" class="stm run hide_run"><a href="#n77">77</a></p>
<p id="n78" class="stm run hide_run"><a href="#n78">78</a></p>
<p id="n79" class="stm run hide_run"><a href="#n79">79</a></p>
<p id="n80" class="stm run hide_run"><a href="#n80">80</a></p>
<p id="n81" class="stm run hide_run"><a href="#n81">81</a></p>
<p id="n82" class="stm run hide_run"><a href="#n82">82</a></p>
<p id="n83" class="pln"><a href="#n83">83</a></p>
<p id="n84" class="pln"><a href="#n84">84</a></p>
<p id="n85" class="stm run hide_run"><a href="#n85">85</a></p>
<p id="n86" class="stm run hide_run"><a href="#n86">86</a></p>
<p id="n87" class="pln"><a href="#n87">87</a></p>
<p id="n88" class="pln"><a href="#n88">88</a></p>
<p id="n89" class="pln"><a href="#n89">89</a></p>
<p id="n90" class="pln"><a href="#n90">90</a></p>
<p id="n91" class="pln"><a href="#n91">91</a></p>
<p id="n92" class="pln"><a href="#n92">92</a></p>
<p id="n93" class="pln"><a href="#n93">93</a></p>
<p id="n94" class="pln"><a href="#n94">94</a></p>
<p id="n95" class="pln"><a href="#n95">95</a></p>
<p id="n96" class="pln"><a href="#n96">96</a></p>
<p id="n97" class="pln"><a href="#n97">97</a></p>
<p id="n98" class="pln"><a href="#n98">98</a></p>
<p id="n99" class="pln"><a href="#n99">99</a></p>
<p id="n100" class="pln"><a href="#n100">100</a></p>
<p id="n101" class="pln"><a href="#n101">101</a></p>
<p id="n102" class="stm run hide_run"><a href="#n102">102</a></p>
<p id="n103" class="stm run hide_run"><a href="#n103">103</a></p>
<p id="n104" class="stm run hide_run"><a href="#n104">104</a></p>
<p id="n105" class="pln"><a href="#n105">105</a></p>
<p id="n106" class="pln"><a href="#n106">106</a></p>
<p id="n107" class="pln"><a href="#n107">107</a></p>
<p id="n108" class="stm run hide_run"><a href="#n108">108</a></p>
<p id="n109" class="stm run hide_run"><a href="#n109">109</a></p>
<p id="n110" class="pln"><a href="#n110">110</a></p>
<p id="n111" class="pln"><a href="#n111">111</a></p>
<p id="n112" class="pln"><a href="#n112">112</a></p>
<p id="n113" class="pln"><a href="#n113">113</a></p>
<p id="n114" class="stm run hide_run"><a href="#n114">114</a></p>
<p id="n115" class="stm run hide_run"><a href="#n115">115</a></p>
<p id="n116" class="stm run hide_run"><a href="#n116">116</a></p>
<p id="n117" class="pln"><a href="#n117">117</a></p>
<p id="n118" class="pln"><a href="#n118">118</a></p>
<p id="n119" class="stm run hide_run"><a href="#n119">119</a></p>
<p id="n120" class="stm run hide_run"><a href="#n120">120</a></p>
<p id="n121" class="pln"><a href="#n121">121</a></p>
<p id="n122" class="pln"><a href="#n122">122</a></p>
<p id="n123" class="pln"><a href="#n123">123</a></p>
<p id="n124" class="pln"><a href="#n124">124</a></p>
<p id="n125" class="stm run hide_run"><a href="#n125">125</a></p>
<p id="n126" class="stm run hide_run"><a href="#n126">126</a></p>
<p id="n127" class="stm run hide_run"><a href="#n127">127</a></p>
<p id="n128" class="pln"><a href="#n128">128</a></p>
<p id="n129" class="pln"><a href="#n129">129</a></p>
<p id="n130" class="stm run hide_run"><a href="#n130">130</a></p>
<p id="n131" class="stm run hide_run"><a href="#n131">131</a></p>
<p id="n132" class="pln"><a href="#n132">132</a></p>
<p id="n133" class="pln"><a href="#n133">133</a></p>
<p id="n134" class="pln"><a href="#n134">134</a></p>
<p id="n135" class="pln"><a href="#n135">135</a></p>
<p id="n136" class="stm run hide_run"><a href="#n136">136</a></p>
<p id="n137" class="stm run hide_run"><a href="#n137">137</a></p>
<p id="n138" class="stm run hide_run"><a href="#n138">138</a></p>
<p id="n139" class="pln"><a href="#n139">139</a></p>
<p id="n140" class="pln"><a href="#n140">140</a></p>
<p id="n141" class="stm run hide_run"><a href="#n141">141</a></p>
<p id="n142" class="stm run hide_run"><a href="#n142">142</a></p>
<p id="n143" class="pln"><a href="#n143">143</a></p>
<p id="n144" class="pln"><a href="#n144">144</a></p>
<p id="n145" class="pln"><a href="#n145">145</a></p>
<p id="n146" class="pln"><a href="#n146">146</a></p>
<p id="n147" class="pln"><a href="#n147">147</a></p>
<p id="n148" class="stm run hide_run"><a href="#n148">148</a></p>
<p id="n149" class="stm run hide_run"><a href="#n149">149</a></p>
<p id="n150" class="stm run hide_run"><a href="#n150">150</a></p>
<p id="n151" class="pln"><a href="#n151">151</a></p>
<p id="n152" class="pln"><a href="#n152">152</a></p>
<p id="n153" class="pln"><a href="#n153">153</a></p>
<p id="n154" class="stm run hide_run"><a href="#n154">154</a></p>
<p id="n155" class="stm run hide_run"><a href="#n155">155</a></p>
<p id="n156" class="pln"><a href="#n156">156</a></p>
<p id="n157" class="pln"><a href="#n157">157</a></p>
<p id="n158" class="pln"><a href="#n158">158</a></p>
<p id="n159" class="pln"><a href="#n159">159</a></p>
<p id="n160" class="pln"><a href="#n160">160</a></p>
<p id="n161" class="pln"><a href="#n161">161</a></p>
<p id="n162" class="stm run hide_run"><a href="#n162">162</a></p>
<p id="n163" class="stm run hide_run"><a href="#n163">163</a></p>
<p id="n164" class="stm run hide_run"><a href="#n164">164</a></p>
<p id="n165" class="pln"><a href="#n165">165</a></p>
<p id="n166" class="pln"><a href="#n166">166</a></p>
<p id="n167" class="pln"><a href="#n167">167</a></p>
<p id="n168" class="stm run hide_run"><a href="#n168">168</a></p>
<p id="n169" class="stm run hide_run"><a href="#n169">169</a></p>
<p id="n170" class="pln"><a href="#n170">170</a></p>
<p id="n171" class="pln"><a href="#n171">171</a></p>
<p id="n172" class="pln"><a href="#n172">172</a></p>
<p id="n173" class="pln"><a href="#n173">173</a></p>
<p id="n174" class="pln"><a href="#n174">174</a></p>
<p id="n175" class="stm run hide_run"><a href="#n175">175</a></p>
<p id="n176" class="stm run hide_run"><a href="#n176">176</a></p>
<p id="n177" class="stm run hide_run"><a href="#n177">177</a></p>
<p id="n178" class="pln"><a href="#n178">178</a></p>
<p id="n179" class="pln"><a href="#n179">179</a></p>
<p id="n180" class="stm run hide_run"><a href="#n180">180</a></p>
<p id="n181" class="stm run hide_run"><a href="#n181">181</a></p>
<p id="n182" class="pln"><a href="#n182">182</a></p>
<p id="n183" class="pln"><a href="#n183">183</a></p>
<p id="n184" class="pln"><a href="#n184">184</a></p>
<p id="n185" class="pln"><a href="#n185">185</a></p>
<p id="n186" class="pln"><a href="#n186">186</a></p>
<p id="n187" class="pln"><a href="#n187">187</a></p>
<p id="n188" class="pln"><a href="#n188">188</a></p>
<p id="n189" class="stm run hide_run"><a href="#n189">189</a></p>
<p id="n190" class="pln"><a href="#n190">190</a></p>
<p id="n191" class="pln"><a href="#n191">191</a></p>
<p id="n192" class="pln"><a href="#n192">192</a></p>
<p id="n193" class="pln"><a href="#n193">193</a></p>
<p id="n194" class="pln"><a href="#n194">194</a></p>
<p id="n195" class="stm run hide_run"><a href="#n195">195</a></p>
<p id="n196" class="stm run hide_run"><a href="#n196">196</a></p>
<p id="n197" class="stm mis"><a href="#n197">197</a></p>
<p id="n198" class="stm mis"><a href="#n198">198</a></p>
<p id="n199" class="stm mis"><a href="#n199">199</a></p>
<p id="n200" class="stm mis"><a href="#n200">200</a></p>
<p id="n201" class="stm mis"><a href="#n201">201</a></p>
<p id="n202" class="stm mis"><a href="#n202">202</a></p>
<p id="n203" class="stm mis"><a href="#n203">203</a></p>
<p id="n204" class="stm mis"><a href="#n204">204</a></p>
<p id="n205" class="pln"><a href="#n205">205</a></p>
<p id="n206" class="stm mis"><a href="#n206">206</a></p>
<p id="n207" class="stm mis"><a href="#n207">207</a></p>
<p id="n208" class="stm mis"><a href="#n208">208</a></p>
<p id="n209" class="stm mis"><a href="#n209">209</a></p>
<p id="n210" class="stm mis"><a href="#n210">210</a></p>
<p id="n211" class="stm mis"><a href="#n211">211</a></p>
<p id="n212" class="pln"><a href="#n212">212</a></p>
<p id="n213" class="stm run hide_run"><a href="#n213">213</a></p>
<p id="n214" class="stm run hide_run"><a href="#n214">214</a></p>
<p id="n215" class="stm mis"><a href="#n215">215</a></p>
<p id="n216" class="stm mis"><a href="#n216">216</a></p>
<p id="n217" class="stm mis"><a href="#n217">217</a></p>
<p id="n218" class="stm mis"><a href="#n218">218</a></p>
<p id="n219" class="stm mis"><a href="#n219">219</a></p>
<p id="n220" class="pln"><a href="#n220">220</a></p>
<p id="n221" class="stm run hide_run"><a href="#n221">221</a></p>
<p id="n222" class="stm run hide_run"><a href="#n222">222</a></p>
<p id="n223" class="stm mis"><a href="#n223">223</a></p>
<p id="n224" class="pln"><a href="#n224">224</a></p>
<p id="n225" class="stm run hide_run"><a href="#n225">225</a></p>
<p id="n226" class="stm mis"><a href="#n226">226</a></p>
<p id="n227" class="stm mis"><a href="#n227">227</a></p>
<p id="n228" class="stm mis"><a href="#n228">228</a></p>
<p id="n229" class="stm mis"><a href="#n229">229</a></p>
<p id="n230" class="stm mis"><a href="#n230">230</a></p>
<p id="n231" class="stm mis"><a href="#n231">231</a></p>
<p id="n232" class="pln"><a href="#n232">232</a></p>
<p id="n233" class="stm run hide_run"><a href="#n233">233</a></p>
<p id="n234" class="stm run hide_run"><a href="#n234">234</a></p>
<p id="n235" class="stm mis"><a href="#n235">235</a></p>
<p id="n236" class="pln"><a href="#n236">236</a></p>
<p id="n237" class="stm run hide_run"><a href="#n237">237</a></p>
<p id="n238" class="stm mis"><a href="#n238">238</a></p>
<p id="n239" class="stm mis"><a href="#n239">239</a></p>
<p id="n240" class="stm mis"><a href="#n240">240</a></p>
<p id="n241" class="stm mis"><a href="#n241">241</a></p>
<p id="n242" class="stm mis"><a href="#n242">242</a></p>
<p id="n243" class="stm mis"><a href="#n243">243</a></p>
<p id="n244" class="stm mis"><a href="#n244">244</a></p>
<p id="n245" class="stm mis"><a href="#n245">245</a></p>
<p id="n246" class="pln"><a href="#n246">246</a></p>
<p id="n247" class="stm run hide_run"><a href="#n247">247</a></p>
<p id="n248" class="stm mis"><a href="#n248">248</a></p>
<p id="n249" class="stm mis"><a href="#n249">249</a></p>
<p id="n250" class="stm mis"><a href="#n250">250</a></p>
<p id="n251" class="stm mis"><a href="#n251">251</a></p>
<p id="n252" class="stm mis"><a href="#n252">252</a></p>
<p id="n253" class="pln"><a href="#n253">253</a></p>
<p id="n254" class="stm run hide_run"><a href="#n254">254</a></p>
<p id="n255" class="stm mis"><a href="#n255">255</a></p>
<p id="n256" class="stm mis"><a href="#n256">256</a></p>
<p id="n257" class="stm mis"><a href="#n257">257</a></p>
<p id="n258" class="stm mis"><a href="#n258">258</a></p>
<p id="n259" class="stm mis"><a href="#n259">259</a></p>
<p id="n260" class="pln"><a href="#n260">260</a></p>
<p id="n261" class="stm run hide_run"><a href="#n261">261</a></p>
<p id="n262" class="stm mis"><a href="#n262">262</a></p>
<p id="n263" class="stm mis"><a href="#n263">263</a></p>
<p id="n264" class="stm mis"><a href="#n264">264</a></p>
<p id="n265" class="stm mis"><a href="#n265">265</a></p>
<p id="n266" class="stm mis"><a href="#n266">266</a></p>
<p id="n267" class="stm mis"><a href="#n267">267</a></p>

            </td>
            <td class="text">
<p id="t1" class="pln"><span class="com"># SECUREAUTH LABS. Copyright 2018 SecureAuth Corporation. All rights reserved.</span><span class="strut">&nbsp;</span></p>
<p id="t2" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t3" class="pln"><span class="com"># This software is provided under under a slightly modified version</span><span class="strut">&nbsp;</span></p>
<p id="t4" class="pln"><span class="com"># of the Apache Software License. See the accompanying LICENSE file</span><span class="strut">&nbsp;</span></p>
<p id="t5" class="pln"><span class="com"># for more information.</span><span class="strut">&nbsp;</span></p>
<p id="t6" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t7" class="pln"><span class="com"># Author: Alberto Solino (@agsolino)</span><span class="strut">&nbsp;</span></p>
<p id="t8" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t9" class="pln"><span class="com"># Description:</span><span class="strut">&nbsp;</span></p>
<p id="t10" class="pln"><span class="com">#   [MS-VDS]: Virtual Disk Service (VDS) Protocol</span><span class="strut">&nbsp;</span></p>
<p id="t11" class="pln"><span class="com">#             This was used as a way to test the DCOM runtime. Further </span><span class="strut">&nbsp;</span></p>
<p id="t12" class="pln"><span class="com">#             testing is needed to verify it is working as expected</span><span class="strut">&nbsp;</span></p>
<p id="t13" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t14" class="pln"><span class="com">#   Best way to learn how to use these calls is to grab the protocol standard</span><span class="strut">&nbsp;</span></p>
<p id="t15" class="pln"><span class="com">#   so you understand what the call does, and then read the test case located</span><span class="strut">&nbsp;</span></p>
<p id="t16" class="pln"><span class="com">#   at https://github.com/SecureAuthCorp/impacket/tree/master/tests/SMB_RPC</span><span class="strut">&nbsp;</span></p>
<p id="t17" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t18" class="pln"><span class="com">#   Since DCOM is like an OO RPC, instead of helper functions you will see the </span><span class="strut">&nbsp;</span></p>
<p id="t19" class="pln"><span class="com">#   classes described in the standards developed. </span><span class="strut">&nbsp;</span></p>
<p id="t20" class="pln"><span class="com">#   There are test cases for them too. </span><span class="strut">&nbsp;</span></p>
<p id="t21" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t22" class="stm run hide_run"><span class="key">from</span> <span class="nam">__future__</span> <span class="key">import</span> <span class="nam">division</span><span class="strut">&nbsp;</span></p>
<p id="t23" class="stm run hide_run"><span class="key">from</span> <span class="nam">__future__</span> <span class="key">import</span> <span class="nam">print_function</span><span class="strut">&nbsp;</span></p>
<p id="t24" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">dcerpc</span><span class="op">.</span><span class="nam">v5</span><span class="op">.</span><span class="nam">ndr</span> <span class="key">import</span> <span class="nam">NDRSTRUCT</span><span class="op">,</span> <span class="nam">NDRUniConformantVaryingArray</span><span class="op">,</span> <span class="nam">NDRENUM</span><span class="strut">&nbsp;</span></p>
<p id="t25" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">dcerpc</span><span class="op">.</span><span class="nam">v5</span><span class="op">.</span><span class="nam">dcomrt</span> <span class="key">import</span> <span class="nam">DCOMCALL</span><span class="op">,</span> <span class="nam">DCOMANSWER</span><span class="op">,</span> <span class="nam">IRemUnknown2</span><span class="op">,</span> <span class="nam">PMInterfacePointer</span><span class="op">,</span> <span class="nam">INTERFACE</span><span class="strut">&nbsp;</span></p>
<p id="t26" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">dcerpc</span><span class="op">.</span><span class="nam">v5</span><span class="op">.</span><span class="nam">dtypes</span> <span class="key">import</span> <span class="nam">LPWSTR</span><span class="op">,</span> <span class="nam">ULONG</span><span class="op">,</span> <span class="nam">DWORD</span><span class="op">,</span> <span class="nam">SHORT</span><span class="op">,</span> <span class="nam">GUID</span><span class="strut">&nbsp;</span></p>
<p id="t27" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">dcerpc</span><span class="op">.</span><span class="nam">v5</span><span class="op">.</span><span class="nam">rpcrt</span> <span class="key">import</span> <span class="nam">DCERPCException</span><span class="strut">&nbsp;</span></p>
<p id="t28" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">dcerpc</span><span class="op">.</span><span class="nam">v5</span><span class="op">.</span><span class="nam">enum</span> <span class="key">import</span> <span class="nam">Enum</span><span class="strut">&nbsp;</span></p>
<p id="t29" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span> <span class="key">import</span> <span class="nam">hresult_errors</span><span class="strut">&nbsp;</span></p>
<p id="t30" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span><span class="op">.</span><span class="nam">uuid</span> <span class="key">import</span> <span class="nam">string_to_bin</span><span class="strut">&nbsp;</span></p>
<p id="t31" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t32" class="stm run hide_run"><span class="key">class</span> <span class="nam">DCERPCSessionError</span><span class="op">(</span><span class="nam">DCERPCException</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t33" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">error_string</span><span class="op">=</span><span class="key">None</span><span class="op">,</span> <span class="nam">error_code</span><span class="op">=</span><span class="key">None</span><span class="op">,</span> <span class="nam">packet</span><span class="op">=</span><span class="key">None</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t34" class="stm mis">        <span class="nam">DCERPCException</span><span class="op">.</span><span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">error_string</span><span class="op">,</span> <span class="nam">error_code</span><span class="op">,</span> <span class="nam">packet</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t35" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t36" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__str__</span><span class="op">(</span> <span class="nam">self</span> <span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t37" class="stm mis">        <span class="key">if</span> <span class="nam">self</span><span class="op">.</span><span class="nam">error_code</span> <span class="key">in</span> <span class="nam">hresult_errors</span><span class="op">.</span><span class="nam">ERROR_MESSAGES</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t38" class="stm mis">            <span class="nam">error_msg_short</span> <span class="op">=</span> <span class="nam">hresult_errors</span><span class="op">.</span><span class="nam">ERROR_MESSAGES</span><span class="op">[</span><span class="nam">self</span><span class="op">.</span><span class="nam">error_code</span><span class="op">]</span><span class="op">[</span><span class="num">0</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t39" class="stm mis">            <span class="nam">error_msg_verbose</span> <span class="op">=</span> <span class="nam">hresult_errors</span><span class="op">.</span><span class="nam">ERROR_MESSAGES</span><span class="op">[</span><span class="nam">self</span><span class="op">.</span><span class="nam">error_code</span><span class="op">]</span><span class="op">[</span><span class="num">1</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t40" class="stm mis">            <span class="key">return</span> <span class="str">'VDS SessionError: code: 0x%x - %s - %s'</span> <span class="op">%</span> <span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">error_code</span><span class="op">,</span> <span class="nam">error_msg_short</span><span class="op">,</span> <span class="nam">error_msg_verbose</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t41" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t42" class="stm mis">            <span class="key">return</span> <span class="str">'VDS SessionError: unknown error code: 0x%x'</span> <span class="op">%</span> <span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">error_code</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t43" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t44" class="pln"><span class="com">################################################################################</span><span class="strut">&nbsp;</span></p>
<p id="t45" class="pln"><span class="com"># CONSTANTS</span><span class="strut">&nbsp;</span></p>
<p id="t46" class="pln"><span class="com">################################################################################</span><span class="strut">&nbsp;</span></p>
<p id="t47" class="pln"><span class="com"># 1.9 Standards Assignments</span><span class="strut">&nbsp;</span></p>
<p id="t48" class="stm run hide_run"><span class="nam">CLSID_VirtualDiskService</span> <span class="op">=</span> <span class="nam">string_to_bin</span><span class="op">(</span><span class="str">'7D1933CB-86F6-4A98-8628-01BE94C9A575'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t49" class="stm run hide_run"><span class="nam">IID_IEnumVdsObject</span> <span class="op">=</span> <span class="nam">string_to_bin</span><span class="op">(</span><span class="str">'118610B7-8D94-4030-B5B8-500889788E4E'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t50" class="stm run hide_run"><span class="nam">IID_IVdsAdviseSink</span> <span class="op">=</span> <span class="nam">string_to_bin</span><span class="op">(</span><span class="str">'8326CD1D-CF59-4936-B786-5EFC08798E25'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t51" class="stm run hide_run"><span class="nam">IID_IVdsAsync</span> <span class="op">=</span> <span class="nam">string_to_bin</span><span class="op">(</span><span class="str">'D5D23B6D-5A55-4492-9889-397A3C2D2DBC'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t52" class="stm run hide_run"><span class="nam">IID_IVdsServiceInitialization</span> <span class="op">=</span> <span class="nam">string_to_bin</span><span class="op">(</span><span class="str">'4AFC3636-DB01-4052-80C3-03BBCB8D3C69'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t53" class="stm run hide_run"><span class="nam">IID_IVdsService</span> <span class="op">=</span> <span class="nam">string_to_bin</span><span class="op">(</span><span class="str">'0818A8EF-9BA9-40D8-A6F9-E22833CC771E'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t54" class="stm run hide_run"><span class="nam">IID_IVdsSwProvider</span> <span class="op">=</span> <span class="nam">string_to_bin</span><span class="op">(</span><span class="str">'9AA58360-CE33-4F92-B658-ED24B14425B8'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t55" class="stm run hide_run"><span class="nam">IID_IVdsProvider</span> <span class="op">=</span> <span class="nam">string_to_bin</span><span class="op">(</span><span class="str">'10C5E575-7984-4E81-A56B-431F5F92AE42'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t56" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t57" class="stm run hide_run"><span class="nam">error_status_t</span> <span class="op">=</span> <span class="nam">ULONG</span><span class="strut">&nbsp;</span></p>
<p id="t58" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t59" class="pln"><span class="com"># 2.2.1.1.3 VDS_OBJECT_ID</span><span class="strut">&nbsp;</span></p>
<p id="t60" class="stm run hide_run"><span class="nam">VDS_OBJECT_ID</span> <span class="op">=</span> <span class="nam">GUID</span><span class="strut">&nbsp;</span></p>
<p id="t61" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t62" class="pln"><span class="com">################################################################################</span><span class="strut">&nbsp;</span></p>
<p id="t63" class="pln"><span class="com"># STRUCTURES</span><span class="strut">&nbsp;</span></p>
<p id="t64" class="pln"><span class="com">################################################################################</span><span class="strut">&nbsp;</span></p>
<p id="t65" class="pln"><span class="com"># 2.2.2.1.3.1 VDS_SERVICE_PROP</span><span class="strut">&nbsp;</span></p>
<p id="t66" class="stm run hide_run"><span class="key">class</span> <span class="nam">VDS_SERVICE_PROP</span><span class="op">(</span><span class="nam">NDRSTRUCT</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t67" class="stm run hide_run">    <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t68" class="pln">        <span class="op">(</span><span class="str">'pwszVersion'</span><span class="op">,</span><span class="nam">LPWSTR</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t69" class="pln">        <span class="op">(</span><span class="str">'ulFlags'</span><span class="op">,</span><span class="nam">ULONG</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t70" class="pln">    <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t71" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t72" class="stm run hide_run"><span class="key">class</span> <span class="nam">OBJECT_ARRAY</span><span class="op">(</span><span class="nam">NDRUniConformantVaryingArray</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t73" class="stm run hide_run">    <span class="nam">item</span> <span class="op">=</span> <span class="nam">PMInterfacePointer</span><span class="strut">&nbsp;</span></p>
<p id="t74" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t75" class="pln"><span class="com"># 2.2.2.7.1.1 VDS_PROVIDER_TYPE</span><span class="strut">&nbsp;</span></p>
<p id="t76" class="stm run hide_run"><span class="key">class</span> <span class="nam">VDS_PROVIDER_TYPE</span><span class="op">(</span><span class="nam">NDRENUM</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t77" class="stm run hide_run">    <span class="key">class</span> <span class="nam">enumItems</span><span class="op">(</span><span class="nam">Enum</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t78" class="stm run hide_run">        <span class="nam">VDS_PT_UNKNOWN</span>     <span class="op">=</span> <span class="num">0</span><span class="strut">&nbsp;</span></p>
<p id="t79" class="stm run hide_run">        <span class="nam">VDS_PT_SOFTWARE</span>    <span class="op">=</span> <span class="num">1</span><span class="strut">&nbsp;</span></p>
<p id="t80" class="stm run hide_run">        <span class="nam">VDS_PT_HARDWARE</span>    <span class="op">=</span> <span class="num">2</span><span class="strut">&nbsp;</span></p>
<p id="t81" class="stm run hide_run">        <span class="nam">VDS_PT_VIRTUALDISK</span> <span class="op">=</span> <span class="num">3</span><span class="strut">&nbsp;</span></p>
<p id="t82" class="stm run hide_run">        <span class="nam">VDS_PT_MAX</span>         <span class="op">=</span> <span class="num">4</span><span class="strut">&nbsp;</span></p>
<p id="t83" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t84" class="pln"><span class="com"># 2.2.2.7.2.1 VDS_PROVIDER_PROP</span><span class="strut">&nbsp;</span></p>
<p id="t85" class="stm run hide_run"><span class="key">class</span> <span class="nam">VDS_PROVIDER_PROP</span><span class="op">(</span><span class="nam">NDRSTRUCT</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t86" class="stm run hide_run">    <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t87" class="pln">        <span class="op">(</span><span class="str">'id'</span><span class="op">,</span><span class="nam">VDS_OBJECT_ID</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t88" class="pln">        <span class="op">(</span><span class="str">'pwszName'</span><span class="op">,</span><span class="nam">LPWSTR</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t89" class="pln">        <span class="op">(</span><span class="str">'guidVersionId'</span><span class="op">,</span><span class="nam">GUID</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t90" class="pln">        <span class="op">(</span><span class="str">'pwszVersion'</span><span class="op">,</span><span class="nam">LPWSTR</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t91" class="pln">        <span class="op">(</span><span class="str">'type'</span><span class="op">,</span><span class="nam">VDS_PROVIDER_TYPE</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t92" class="pln">        <span class="op">(</span><span class="str">'ulFlags'</span><span class="op">,</span><span class="nam">ULONG</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t93" class="pln">        <span class="op">(</span><span class="str">'ulStripeSizeFlags'</span><span class="op">,</span><span class="nam">ULONG</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t94" class="pln">        <span class="op">(</span><span class="str">'sRebuildPriority'</span><span class="op">,</span><span class="nam">SHORT</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t95" class="pln">    <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t96" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t97" class="pln"><span class="com">################################################################################</span><span class="strut">&nbsp;</span></p>
<p id="t98" class="pln"><span class="com"># RPC CALLS</span><span class="strut">&nbsp;</span></p>
<p id="t99" class="pln"><span class="com">################################################################################</span><span class="strut">&nbsp;</span></p>
<p id="t100" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t101" class="pln"><span class="com"># 3.4.5.2.5.1 IVdsServiceInitialization::Initialize (Opnum 3)</span><span class="strut">&nbsp;</span></p>
<p id="t102" class="stm run hide_run"><span class="key">class</span> <span class="nam">IVdsServiceInitialization_Initialize</span><span class="op">(</span><span class="nam">DCOMCALL</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t103" class="stm run hide_run">    <span class="nam">opnum</span> <span class="op">=</span> <span class="num">3</span><span class="strut">&nbsp;</span></p>
<p id="t104" class="stm run hide_run">    <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t105" class="pln">       <span class="op">(</span><span class="str">'pwszMachineName'</span><span class="op">,</span> <span class="nam">LPWSTR</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t106" class="pln">    <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t107" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t108" class="stm run hide_run"><span class="key">class</span> <span class="nam">IVdsServiceInitialization_InitializeResponse</span><span class="op">(</span><span class="nam">DCOMANSWER</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t109" class="stm run hide_run">    <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t110" class="pln">       <span class="op">(</span><span class="str">'ErrorCode'</span><span class="op">,</span> <span class="nam">error_status_t</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t111" class="pln">    <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t112" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t113" class="pln"><span class="com"># 3.4.5.2.4.1 IVdsService::IsServiceReady (Opnum 3)</span><span class="strut">&nbsp;</span></p>
<p id="t114" class="stm run hide_run"><span class="key">class</span> <span class="nam">IVdsService_IsServiceReady</span><span class="op">(</span><span class="nam">DCOMCALL</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t115" class="stm run hide_run">    <span class="nam">opnum</span> <span class="op">=</span> <span class="num">3</span><span class="strut">&nbsp;</span></p>
<p id="t116" class="stm run hide_run">    <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t117" class="pln">    <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t118" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t119" class="stm run hide_run"><span class="key">class</span> <span class="nam">IVdsService_IsServiceReadyResponse</span><span class="op">(</span><span class="nam">DCOMANSWER</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t120" class="stm run hide_run">    <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t121" class="pln">       <span class="op">(</span><span class="str">'ErrorCode'</span><span class="op">,</span> <span class="nam">error_status_t</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t122" class="pln">    <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t123" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t124" class="pln"><span class="com"># 3.4.5.2.4.2 IVdsService::WaitForServiceReady (Opnum 4)</span><span class="strut">&nbsp;</span></p>
<p id="t125" class="stm run hide_run"><span class="key">class</span> <span class="nam">IVdsService_WaitForServiceReady</span><span class="op">(</span><span class="nam">DCOMCALL</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t126" class="stm run hide_run">    <span class="nam">opnum</span> <span class="op">=</span> <span class="num">4</span><span class="strut">&nbsp;</span></p>
<p id="t127" class="stm run hide_run">    <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t128" class="pln">    <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t129" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t130" class="stm run hide_run"><span class="key">class</span> <span class="nam">IVdsService_WaitForServiceReadyResponse</span><span class="op">(</span><span class="nam">DCOMANSWER</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t131" class="stm run hide_run">    <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t132" class="pln">       <span class="op">(</span><span class="str">'ErrorCode'</span><span class="op">,</span> <span class="nam">error_status_t</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t133" class="pln">    <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t134" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t135" class="pln"><span class="com"># 3.4.5.2.4.3 IVdsService::GetProperties (Opnum 5)</span><span class="strut">&nbsp;</span></p>
<p id="t136" class="stm run hide_run"><span class="key">class</span> <span class="nam">IVdsService_GetProperties</span><span class="op">(</span><span class="nam">DCOMCALL</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t137" class="stm run hide_run">    <span class="nam">opnum</span> <span class="op">=</span> <span class="num">5</span><span class="strut">&nbsp;</span></p>
<p id="t138" class="stm run hide_run">    <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t139" class="pln">    <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t140" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t141" class="stm run hide_run"><span class="key">class</span> <span class="nam">IVdsService_GetPropertiesResponse</span><span class="op">(</span><span class="nam">DCOMANSWER</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t142" class="stm run hide_run">    <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t143" class="pln">       <span class="op">(</span><span class="str">'pServiceProp'</span><span class="op">,</span> <span class="nam">VDS_SERVICE_PROP</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t144" class="pln">       <span class="op">(</span><span class="str">'ErrorCode'</span><span class="op">,</span> <span class="nam">error_status_t</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t145" class="pln">    <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t146" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t147" class="pln"><span class="com"># 3.4.5.2.4.4 IVdsService::QueryProviders (Opnum 6)</span><span class="strut">&nbsp;</span></p>
<p id="t148" class="stm run hide_run"><span class="key">class</span> <span class="nam">IVdsService_QueryProviders</span><span class="op">(</span><span class="nam">DCOMCALL</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t149" class="stm run hide_run">    <span class="nam">opnum</span> <span class="op">=</span> <span class="num">6</span><span class="strut">&nbsp;</span></p>
<p id="t150" class="stm run hide_run">    <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t151" class="pln">        <span class="op">(</span><span class="str">'masks'</span><span class="op">,</span> <span class="nam">DWORD</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t152" class="pln">    <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t153" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t154" class="stm run hide_run"><span class="key">class</span> <span class="nam">IVdsService_QueryProvidersResponse</span><span class="op">(</span><span class="nam">DCOMANSWER</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t155" class="stm run hide_run">    <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t156" class="pln">       <span class="op">(</span><span class="str">'ppEnum'</span><span class="op">,</span> <span class="nam">PMInterfacePointer</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t157" class="pln">       <span class="op">(</span><span class="str">'ErrorCode'</span><span class="op">,</span> <span class="nam">error_status_t</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t158" class="pln">    <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t159" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t160" class="pln"><span class="com"># 3.1.1.1 IEnumVdsObject Interface</span><span class="strut">&nbsp;</span></p>
<p id="t161" class="pln"><span class="com"># 3.4.5.2.1.1 IEnumVdsObject::Next (Opnum 3)</span><span class="strut">&nbsp;</span></p>
<p id="t162" class="stm run hide_run"><span class="key">class</span> <span class="nam">IEnumVdsObject_Next</span><span class="op">(</span><span class="nam">DCOMCALL</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t163" class="stm run hide_run">    <span class="nam">opnum</span> <span class="op">=</span> <span class="num">3</span><span class="strut">&nbsp;</span></p>
<p id="t164" class="stm run hide_run">    <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t165" class="pln">       <span class="op">(</span><span class="str">'celt'</span><span class="op">,</span> <span class="nam">ULONG</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t166" class="pln">    <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t167" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t168" class="stm run hide_run"><span class="key">class</span> <span class="nam">IEnumVdsObject_NextResponse</span><span class="op">(</span><span class="nam">DCOMANSWER</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t169" class="stm run hide_run">    <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t170" class="pln">       <span class="op">(</span><span class="str">'ppObjectArray'</span><span class="op">,</span> <span class="nam">OBJECT_ARRAY</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t171" class="pln">       <span class="op">(</span><span class="str">'pcFetched'</span><span class="op">,</span> <span class="nam">ULONG</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t172" class="pln">       <span class="op">(</span><span class="str">'ErrorCode'</span><span class="op">,</span> <span class="nam">error_status_t</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t173" class="pln">    <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t174" class="pln"><span class="com"># 3.4.5.2.14.1 IVdsProvider::GetProperties (Opnum 3)</span><span class="strut">&nbsp;</span></p>
<p id="t175" class="stm run hide_run"><span class="key">class</span> <span class="nam">IVdsProvider_GetProperties</span><span class="op">(</span><span class="nam">DCOMCALL</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t176" class="stm run hide_run">    <span class="nam">opnum</span> <span class="op">=</span> <span class="num">3</span><span class="strut">&nbsp;</span></p>
<p id="t177" class="stm run hide_run">    <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t178" class="pln">    <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t179" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t180" class="stm run hide_run"><span class="key">class</span> <span class="nam">IVdsProvider_GetPropertiesResponse</span><span class="op">(</span><span class="nam">DCOMANSWER</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t181" class="stm run hide_run">    <span class="nam">structure</span> <span class="op">=</span> <span class="op">(</span><span class="strut">&nbsp;</span></p>
<p id="t182" class="pln">       <span class="op">(</span><span class="str">'pProviderProp'</span><span class="op">,</span> <span class="nam">VDS_PROVIDER_PROP</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t183" class="pln">       <span class="op">(</span><span class="str">'ErrorCode'</span><span class="op">,</span> <span class="nam">error_status_t</span><span class="op">)</span><span class="op">,</span><span class="strut">&nbsp;</span></p>
<p id="t184" class="pln">    <span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t185" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t186" class="pln"><span class="com">################################################################################</span><span class="strut">&nbsp;</span></p>
<p id="t187" class="pln"><span class="com"># OPNUMs and their corresponding structures</span><span class="strut">&nbsp;</span></p>
<p id="t188" class="pln"><span class="com">################################################################################</span><span class="strut">&nbsp;</span></p>
<p id="t189" class="stm run hide_run"><span class="nam">OPNUMS</span> <span class="op">=</span> <span class="op">{</span><span class="strut">&nbsp;</span></p>
<p id="t190" class="pln"><span class="op">}</span><span class="strut">&nbsp;</span></p>
<p id="t191" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t192" class="pln"><span class="com">################################################################################</span><span class="strut">&nbsp;</span></p>
<p id="t193" class="pln"><span class="com"># HELPER FUNCTIONS AND INTERFACES</span><span class="strut">&nbsp;</span></p>
<p id="t194" class="pln"><span class="com">################################################################################</span><span class="strut">&nbsp;</span></p>
<p id="t195" class="stm run hide_run"><span class="key">class</span> <span class="nam">IEnumVdsObject</span><span class="op">(</span><span class="nam">IRemUnknown2</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t196" class="stm run hide_run">    <span class="key">def</span> <span class="nam">Next</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">celt</span><span class="op">=</span><span class="num">0xffff</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t197" class="stm mis">        <span class="nam">request</span> <span class="op">=</span> <span class="nam">IEnumVdsObject_Next</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t198" class="stm mis">        <span class="nam">request</span><span class="op">[</span><span class="str">'ORPCthis'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_cinstance</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">get_ORPCthis</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t199" class="stm mis">        <span class="nam">request</span><span class="op">[</span><span class="str">'ORPCthis'</span><span class="op">]</span><span class="op">[</span><span class="str">'flags'</span><span class="op">]</span> <span class="op">=</span> <span class="num">0</span><span class="strut">&nbsp;</span></p>
<p id="t200" class="stm mis">        <span class="nam">request</span><span class="op">[</span><span class="str">'celt'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">celt</span><span class="strut">&nbsp;</span></p>
<p id="t201" class="stm mis">        <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t202" class="stm mis">            <span class="nam">resp</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">request</span><span class="op">(</span><span class="nam">request</span><span class="op">,</span> <span class="nam">uuid</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_iPid</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t203" class="stm mis">        <span class="key">except</span> <span class="nam">Exception</span> <span class="key">as</span> <span class="nam">e</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t204" class="stm mis">            <span class="nam">resp</span> <span class="op">=</span> <span class="nam">e</span><span class="op">.</span><span class="nam">get_packet</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t205" class="pln">            <span class="com"># If it is S_FALSE(1) means less items were returned</span><span class="strut">&nbsp;</span></p>
<p id="t206" class="stm mis">            <span class="key">if</span> <span class="nam">resp</span><span class="op">[</span><span class="str">'ErrorCode'</span><span class="op">]</span> <span class="op">!=</span> <span class="num">1</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t207" class="stm mis">                <span class="key">raise</span><span class="strut">&nbsp;</span></p>
<p id="t208" class="stm mis">        <span class="nam">interfaces</span> <span class="op">=</span> <span class="nam">list</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t209" class="stm mis">        <span class="key">for</span> <span class="nam">interface</span> <span class="key">in</span> <span class="nam">resp</span><span class="op">[</span><span class="str">'ppObjectArray'</span><span class="op">]</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t210" class="stm mis">            <span class="nam">interfaces</span><span class="op">.</span><span class="nam">append</span><span class="op">(</span><span class="nam">IRemUnknown2</span><span class="op">(</span><span class="nam">INTERFACE</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">get_cinstance</span><span class="op">(</span><span class="op">)</span><span class="op">,</span> <span class="str">''</span><span class="op">.</span><span class="nam">join</span><span class="op">(</span><span class="nam">interface</span><span class="op">[</span><span class="str">'abData'</span><span class="op">]</span><span class="op">)</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_ipidRemUnknown</span><span class="op">(</span><span class="op">)</span><span class="op">,</span> <span class="nam">target</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_target</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t211" class="stm mis">        <span class="key">return</span> <span class="nam">interfaces</span><span class="strut">&nbsp;</span></p>
<p id="t212" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t213" class="stm run hide_run"><span class="key">class</span> <span class="nam">IVdsProvider</span><span class="op">(</span><span class="nam">IRemUnknown2</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t214" class="stm run hide_run">    <span class="key">def</span> <span class="nam">GetProperties</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t215" class="stm mis">        <span class="nam">request</span> <span class="op">=</span> <span class="nam">IVdsProvider_GetProperties</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t216" class="stm mis">        <span class="nam">request</span><span class="op">[</span><span class="str">'ORPCthis'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_cinstance</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">get_ORPCthis</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t217" class="stm mis">        <span class="nam">request</span><span class="op">[</span><span class="str">'ORPCthis'</span><span class="op">]</span><span class="op">[</span><span class="str">'flags'</span><span class="op">]</span> <span class="op">=</span> <span class="num">0</span><span class="strut">&nbsp;</span></p>
<p id="t218" class="stm mis">        <span class="nam">resp</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">request</span><span class="op">(</span><span class="nam">request</span><span class="op">,</span> <span class="nam">uuid</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_iPid</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t219" class="stm mis">        <span class="key">return</span> <span class="nam">resp</span><span class="strut">&nbsp;</span></p>
<p id="t220" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t221" class="stm run hide_run"><span class="key">class</span> <span class="nam">IVdsServiceInitialization</span><span class="op">(</span><span class="nam">IRemUnknown2</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t222" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">interface</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t223" class="stm mis">        <span class="nam">IRemUnknown2</span><span class="op">.</span><span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">interface</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t224" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t225" class="stm run hide_run">    <span class="key">def</span> <span class="nam">Initialize</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t226" class="stm mis">        <span class="nam">request</span> <span class="op">=</span> <span class="nam">IVdsServiceInitialization_Initialize</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t227" class="stm mis">        <span class="nam">request</span><span class="op">[</span><span class="str">'ORPCthis'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_cinstance</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">get_ORPCthis</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t228" class="stm mis">        <span class="nam">request</span><span class="op">[</span><span class="str">'ORPCthis'</span><span class="op">]</span><span class="op">[</span><span class="str">'flags'</span><span class="op">]</span> <span class="op">=</span> <span class="num">0</span><span class="strut">&nbsp;</span></p>
<p id="t229" class="stm mis">        <span class="nam">request</span><span class="op">[</span><span class="str">'pwszMachineName'</span><span class="op">]</span> <span class="op">=</span> <span class="str">'\x00'</span><span class="strut">&nbsp;</span></p>
<p id="t230" class="stm mis">        <span class="nam">resp</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">request</span><span class="op">(</span><span class="nam">request</span><span class="op">,</span> <span class="nam">uuid</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_iPid</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t231" class="stm mis">        <span class="key">return</span> <span class="nam">resp</span><span class="strut">&nbsp;</span></p>
<p id="t232" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t233" class="stm run hide_run"><span class="key">class</span> <span class="nam">IVdsService</span><span class="op">(</span><span class="nam">IRemUnknown2</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t234" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">interface</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t235" class="stm mis">        <span class="nam">IRemUnknown2</span><span class="op">.</span><span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">interface</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t236" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t237" class="stm run hide_run">    <span class="key">def</span> <span class="nam">IsServiceReady</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t238" class="stm mis">        <span class="nam">request</span> <span class="op">=</span> <span class="nam">IVdsService_IsServiceReady</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t239" class="stm mis">        <span class="nam">request</span><span class="op">[</span><span class="str">'ORPCthis'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_cinstance</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">get_ORPCthis</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t240" class="stm mis">        <span class="nam">request</span><span class="op">[</span><span class="str">'ORPCthis'</span><span class="op">]</span><span class="op">[</span><span class="str">'flags'</span><span class="op">]</span> <span class="op">=</span> <span class="num">0</span><span class="strut">&nbsp;</span></p>
<p id="t241" class="stm mis">        <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t242" class="stm mis">            <span class="nam">resp</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">request</span><span class="op">(</span><span class="nam">request</span><span class="op">,</span> <span class="nam">uuid</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_iPid</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t243" class="stm mis">        <span class="key">except</span> <span class="nam">Exception</span> <span class="key">as</span> <span class="nam">e</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t244" class="stm mis">            <span class="nam">resp</span> <span class="op">=</span> <span class="nam">e</span><span class="op">.</span><span class="nam">get_packet</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t245" class="stm mis">        <span class="key">return</span> <span class="nam">resp</span><span class="strut">&nbsp;</span></p>
<p id="t246" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t247" class="stm run hide_run">    <span class="key">def</span> <span class="nam">WaitForServiceReady</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t248" class="stm mis">        <span class="nam">request</span> <span class="op">=</span> <span class="nam">IVdsService_WaitForServiceReady</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t249" class="stm mis">        <span class="nam">request</span><span class="op">[</span><span class="str">'ORPCthis'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_cinstance</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">get_ORPCthis</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t250" class="stm mis">        <span class="nam">request</span><span class="op">[</span><span class="str">'ORPCthis'</span><span class="op">]</span><span class="op">[</span><span class="str">'flags'</span><span class="op">]</span> <span class="op">=</span> <span class="num">0</span><span class="strut">&nbsp;</span></p>
<p id="t251" class="stm mis">        <span class="nam">resp</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">request</span><span class="op">(</span><span class="nam">request</span><span class="op">,</span> <span class="nam">uuid</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_iPid</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t252" class="stm mis">        <span class="key">return</span> <span class="nam">resp</span><span class="strut">&nbsp;</span></p>
<p id="t253" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t254" class="stm run hide_run">    <span class="key">def</span> <span class="nam">GetProperties</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t255" class="stm mis">        <span class="nam">request</span> <span class="op">=</span> <span class="nam">IVdsService_GetProperties</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t256" class="stm mis">        <span class="nam">request</span><span class="op">[</span><span class="str">'ORPCthis'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_cinstance</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">get_ORPCthis</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t257" class="stm mis">        <span class="nam">request</span><span class="op">[</span><span class="str">'ORPCthis'</span><span class="op">]</span><span class="op">[</span><span class="str">'flags'</span><span class="op">]</span> <span class="op">=</span> <span class="num">0</span><span class="strut">&nbsp;</span></p>
<p id="t258" class="stm mis">        <span class="nam">resp</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">request</span><span class="op">(</span><span class="nam">request</span><span class="op">,</span> <span class="nam">uuid</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_iPid</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t259" class="stm mis">        <span class="key">return</span> <span class="nam">resp</span><span class="strut">&nbsp;</span></p>
<p id="t260" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t261" class="stm run hide_run">    <span class="key">def</span> <span class="nam">QueryProviders</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">masks</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t262" class="stm mis">        <span class="nam">request</span> <span class="op">=</span> <span class="nam">IVdsService_QueryProviders</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t263" class="stm mis">        <span class="nam">request</span><span class="op">[</span><span class="str">'ORPCthis'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_cinstance</span><span class="op">(</span><span class="op">)</span><span class="op">.</span><span class="nam">get_ORPCthis</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t264" class="stm mis">        <span class="nam">request</span><span class="op">[</span><span class="str">'ORPCthis'</span><span class="op">]</span><span class="op">[</span><span class="str">'flags'</span><span class="op">]</span> <span class="op">=</span> <span class="num">0</span><span class="strut">&nbsp;</span></p>
<p id="t265" class="stm mis">        <span class="nam">request</span><span class="op">[</span><span class="str">'masks'</span><span class="op">]</span> <span class="op">=</span> <span class="nam">masks</span><span class="strut">&nbsp;</span></p>
<p id="t266" class="stm mis">        <span class="nam">resp</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">request</span><span class="op">(</span><span class="nam">request</span><span class="op">,</span> <span class="nam">uuid</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_iPid</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t267" class="stm mis">        <span class="key">return</span> <span class="nam">IEnumVdsObject</span><span class="op">(</span><span class="nam">INTERFACE</span><span class="op">(</span><span class="nam">self</span><span class="op">.</span><span class="nam">get_cinstance</span><span class="op">(</span><span class="op">)</span><span class="op">,</span> <span class="str">''</span><span class="op">.</span><span class="nam">join</span><span class="op">(</span><span class="nam">resp</span><span class="op">[</span><span class="str">'ppEnum'</span><span class="op">]</span><span class="op">[</span><span class="str">'abData'</span><span class="op">]</span><span class="op">)</span><span class="op">,</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_ipidRemUnknown</span><span class="op">(</span><span class="op">)</span><span class="op">,</span> <span class="nam">target</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_target</span><span class="op">(</span><span class="op">)</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>

            </td>
        </tr>
    </table>
</div>

<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v4.5.4</a>,
            created at 2019-09-25 12:47
        </p>
    </div>
</div>

</body>
</html>
